# Announce: Rakudo Star Release 2018.10

## A useful and usable production distribution of Rakudo Perl 6

On behalf of the Rakudo and Perl 6 development teams, I'm pleased to announce
the October 2018 release of "Rakudo Star", a useful and usable production
distribution of Rakudo.  The tarball for this release is available from
<https://rakudo.perl6.org/downloads/star/>.  

Binaries for macOS and Windows (64 bit) are also available at the same
location.

This is a post-Christmas (production) release of Rakudo Star and implements
Perl v6.c. It comes with support for the MoarVM backend (all module tests pass
on supported platforms).  Currently, Star is on a quarterly release cycle. 

Please note that this release of Rakudo Star is not fully functional with the
JVM backend from the Rakudo compiler. Please use the MoarVM backend only.

We make a distinction between the language ("Perl 6" or "Raku") and specific
implementations of the language such as "Rakudo".

This Star release includes [release 2018.10] of the [Rakudo compiler],
version 2018.10 [MoarVM], plus various modules, documentation, and other
resources collected from the community.

[release 2018.10]: https://raw.githubusercontent.com/rakudo/rakudo/2018.10/docs/announce/2018.10.md
[Rakudo compiler]: http://github.com/rakudo/rakudo
[MoarVM]: http://moarvm.org/

The Rakudo compiler changes since the last Rakudo Star release are now listed
in "2018.08.md" and 2018.09.md" under the "rakudo/docs/announce" directory of
the source distribution.
    
This is the first Rakudo Star release that comes with an additional JS backend.
See `6pad` project at  <https://perl6.github.io/6pad/> for running Perl 6 code
directly in your browser.

Important Rakudo bug fixes are now listed at <https://alerts.perl6.org/>

Also see Rakudo Star errata at <https://perl6.org/downloads/>

Deprecation:

  * LWP::Simple is deprecated and will be removed. Please use "HTTP::UserAgent".
  * panda-sub which pointed user to zef now removed.

Notable changes in modules shipped with Rakudo Star:

  * openssl: Bump version 0.1.21.
  * tap-harness6: Bump version to 0.0.4 for coloring
  * zef: version 0.5.3

There are some key features of Perl 6 that Rakudo Star does not yet
handle appropriately, although they will appear in upcoming releases.
Some of the not-quite-there features include:

  * advanced macros
  * some bits of Synopsis 9 and 11

There is an online resource at <http://perl6.org/compilers/features>
that lists the known implemented and missing features of Rakudo's
backends and other Perl 6 implementations.

In many places we've tried to make Rakudo smart enough to inform the
programmer that a given feature isn't implemented, but there are many
that we've missed. Bug reports about missing and broken features are
welcomed at <rakudobug@perl.org>.

See <https://perl6.org/> for links to much more information, including
documentation, example code, tutorials, presentations, reference materials,
design documents, and other supporting resources.  Tutorials are available
under the "docs" directory in the release tarball.

The development team thanks all of the contributors and sponsors for
making Rakudo Star possible. If you would like to contribute, see
<http://rakudo.org/how-to-help>, ask on the <perl6-compiler@perl.org>
mailing list, or join us on IRC \#perl6 on freenode.
